
#ifndef _CPORT_H
#define _CPORT_H
#ifndef _STDIO_H
#include <stdio.h>
#endif
#ifndef _STDLIB
#include <stdlib.h>
#endif
#ifndef _STRING_H
#include <string.h>
#endif
#ifndef _MATH_H
#include <math.h>
#endif
#ifndef _QDOS_H
#include <qdos.h>
#endif
#ifdef __STDC__
#define _P_(params) params
#else
#define _P_(params) ()
#endif
#define JOB_ID(task,tag) (jobid_t)( (((long)(tag))<<16) + (((long)(task))&0xFFFF) )
#define NO_TIMEOUT (timeout_t)-1
#define COLOUR2(cl1,cl2) COLOUR3(cl1,cl2,3)
#define COLOUR3(cl1,cl2,st) ((int)(st)<<6) + (((int)(cl1)^(int)(cl2)<<3) + (int)(cl1))
#define PROCedure
#define FuNction
#define boolean long int
#define endif }
#define endwhile }
#define endfor }
#define endswitch }
#define enddef }
#define FNO(ch) sb_channo[ch].fp
#define dflt_str_size 100
#define compiled 1
#define SB_Pi 3.14159265
typedef struct {
FILE * fp;
chanid_t chanid;
int iscon;
} CP_FILE;
extern CP_FILE sb_channo[];
#define SB_Acos(angle) acos((double)(angle))
#define SB_Acot(angle) acot((double)(angle))
#define SB_Adate(amount) mt_aclck((long)(amount))
#define SB_Arc(fp,x1,y1,x2,y2,a) sd_iarc(fgetchid(fp),NO_TIMEOUT,\
(int)(x1),(int)y1,\
(int)(x2),(int)(y2),(int)(a))
#define SB_Arc_f(fp,x1,y1,x2,y2,a) sd_arc(fgetchid(fp),NO_TIMEOUT,\
(double)(x1),(double)y1,\
(double)(x2),(double)(y2),(double)(a))
#define SB_Asin(angle) asin((double)(angle))
#define SB_At(fp,line,column) _SB_At(fp,(short)(line),(short)(column))
#define SB_Atan(angle) atan((double)(angle))
#define SB_Baud(rate) mt_baud((int)(rate))
#define SB_Beep(a,b,c,d,e,f,g,h) _SB_Beep((unsigned short)(a),(unsigned char)(b),\
(unsigned char)(c),(unsigned char)(d),\
(unsigned short)(e),(unsigned char)(f),\
(unsigned char)(g),(unsigned char)(h) )
#define SB_Beep_n SB_Beep_Off
#define SB_Block(fp,w,h,x,y,c) _SB_Block(fp,(short)(w),(short)(h),(short)(x),(short)(y),(colour_t)(c))
#define SB_Border(fp,width,col) _SB_Border(fp,(short)(width),(colour_t)(col))
#define SB_Circle(fp,xp,yp,rd) sd_ielipse(fgetchid(fp),NO_TIMEOUT,(int)(xp),\
(int)(yp),1,(int)(rd),0)
#define SB_Circle_f(fp,xp,yp,rd) sd_elipse(fgetchid(fp),NO_TIMEOUT,(double)(xp),\
(double)(yp),1.0,(double)(rd),0.0)
#define SB_Close(fp) _SB_Close((CP_FILE *)&fp)
#define SB_Cls(fp,part) _SB_Cls(fp,(short)(part))
#define SB_Copy(from,to) _SB_Copy(from,to,(short)1)
#define SB_Copy_N(from,to) _SB_Copy(from,to,(short)0)
#define SB_Copy_O(from,to) _SB_Copy(from,to,(short)2)
#define SB_Cos(angle) cos((double)(angle))
#define SB_Cot(angle) cot((double)(angle))
#define SB_Csize(fp,h,w) _SB_Csize(fp,(short)(h),(short)(w))
#define SB_Cursor(fp,x,y) sd_pixp(fgetchid(fp),NO_TIMEOUT,(int)(x),(int)(y))
#define SB_Cursor_g(fp,x_origin,y_origin,x,y) \
sd_igcur(fgetchid(fp),NO_TIMEOUT,\
(int)(x_origin),(int)(y_origin),\
(int)(x),(int)(y))
#define SB_Cursor_gf(fp,x_origin,y_origin,x,y) \
sd_gcur(fgetchid(fp),NO_TIMEOUT,\
(double)(x_origin),(double)(y_origin),\
(double)(x),(double)(y))
#define SB_Date() mt_rclck()
#define SB_Date_s(buf,val) _SB_Dateday(buf,(long)(val),0)
#define SB_Day(buf,val) _SB_Dateday(buf,(long)(val),1)
#define SB_Deg(x) x*(180*I_PI)
#define SB_Delete(name) io_delete(name)
#define SB_Elipse(fp,xp,yp,rd,ec,ang) sd_ielipse(fgetchid(fp),NO_TIMEOUT,(int)(xp),\
(int)(yp),(int)(ec),(int)(rd),(int)(ang))
#define SB_Elipse_f(fp,xp,yp,rd,ec,ang) sd_elipse(fgetchid(fp),NO_TIMEOUT,(double)(xp),\
(double)(yp),(double)(ec),(double)(rd),(double)(ang))
#define SB_Exp(angle) exp((double)(angle)
#define SB_Fill(fp,mode) sd_flood(fgetchid(fp),NO_TIMEOUT,(int)(mode))
#define SB_Fill_s(dest,src,l) _SB_Fills(dest,src,(int)(l))
#define SB_Flash(fp,onoff) sd_setfl(fgetchid(fp),NO_TIMEOUT,(int)(onoff))
#define SB_Ink(fp,colour) _SB_Ink(fp,(colour_t)(colour))
#define SB_Instr(str,pattern) (strfnd(pattern,str,0) + 1)
#define SB_Keyrow(row) keyrow((char)row)
#define SB_Lbytes(name,address) _SB_Lbytes(name,(char *)(address))
#define SB_Line(fp,x1,y1,x2,y2) sd_iline(fgetchid(fp),NO_TIMEOUT,\
(int)(x1),(int)(y1),\
(int)(x2),(int)(y2))
#define SB_Line_f(fp,x1,y1,x2,y2) sd_line(fgetchid(fp),NO_TIMEOUT,\
(double)(x1),(double)(y1),\
(double)(x2),(double)(y2))
#define SB_Ln(x) log((double)(x)
#define SB_Log10(x) log10((double)(x))
#define SB_Mode(x) _SB_Mode((int)(x))
#define SB_Open(fp,name) _SB_Open((CP_FILE *)&fp,name,"r+")
#define SB_Open_In(fp,name) _SB_Open((CP_FILE *)&fp,name,"r")
#define SB_Open_New(fp,name) _SB_Open((CP_FILE *)&fp,name,"n+")
#define SB_Open_Over(fp,name) _SB_Open((CP_FILE *)&fp,name,"w+")
#define SB_Over(fp,mode) sd_setmd(fgetchid(fp),NO_TIMEOUT,(int)(mode))
#define SB_Pan(fp,x,part) _SB_Pan(fp,(int)(x),(int)(part))
#define SB_Paper(fp,colour) _SB_Paper(fp,(colour_t)(colour))
#define SB_Peek(address) (char)_SB_Peek((void *)(address),1)
#define SB_Peek_L(address) (long)_SB_Peek((void *)(address),4)
#define SB_Peek_W(address) (short)_SB_Peek((void *)(address),2)
#define SB_Point(fp,x,y) sd_ipoint(fgetchid(fp),NO_TIMEOUT,(int)(x),(int)(y))
#define SB_Point_f(fp,x,y) sd_point(fgetchid(fp),NO_TIMEOUT,(double)(x),(double)(y))
#define SB_Poke(address,val) _SB_Poke((void *)(address),(long)(val),1)
#define SB_Poke_L(address,val) _SB_Poke((void *)(address),(long)(val),4)
#define SB_Poke_W(address,val) _SB_Poke((void *)(address),(long)(val),2)
#define SB_Rad(x) x*(PI/180)
#define SB_Randomise(x) _SB_Randomise((double)x)
#define SB_Read() _SB_Read(restore_at_line)
#define SB_Recol(fp,c0,c1,c2,c3,c4,c5,c6,c7) \
_SB_Recol(fp,(int)(c0),(int)(c1),(int)(c2),(int)(c3),\
(int)(c4),(int)(c5),(int)(c6),(int)(c7) )
#define SB_Respr(size) _SB_Respr((long)(size),0,0)
#define SB_Restore(num) _SB_Restore(num,restore_at_line)
#define SB_Rnd_f _SB_Rnd_f
#define SB_Rnd_i(min,max) _SB_Rnd_i((int)min,(int)max)
#define SB_Sbytes(name,add,len) _SB_Sbytes(name,(char *)(add),(long)(len),0)
#define SB_Scale(fp,s,x,y) sd_iscale(fgetchid(fp),NO_TIMEOUT,\
(int)(s),(int)(x),(int)(y))
#define SB_Scale_f(fp,s,x,y) sd_scale(fgetchid(fp),NO_TIMEOUT,\
(double)(s),(double)(x),(double)(y))
#define SB_Scroll(fp,val,part) _SB_Scroll(fp,(int)(val),(int)(part))
#define SB_Sexec(name,a,l,d) _SB_Lbytes(name,(char *)(a),(long)(l),(long)(d),0)
#define SB_Strip(fp,colour) _SB_Strip(fp,(colour_t)(colour))
#define SB_Under(fp,mode) sd_setul(fgetchid(fp),NO_TIMEOUT,(int)(mode))
#define SB_Window(fp,w,h,x,y) _SB_Window(fp,(short)(w),(short)(h),(short)(x),(short)(y))
void SB_Beep_Off _P_(( void ));
int SB_Beeping _P_(( void ));
void SB_Call _P_(( void *,...));
int SB_Dir _P_(( FILE *,char * ));
int SB_Format _P_(( FILE *,char * ));
int SB_Inkey _P_(( FILE *,int ));
int SB_Input _P_(( FILE *,char *,... ));
int SB_Print _P_(( FILE *,char *,... ));
int _SB_At _P_(( FILE *,short,short ));
void _SB_Beep _P_(( unsigned short,unsigned char,\
unsigned char,unsigned char,\
unsigned short,unsigned char,\
unsigned char,unsigned char));
int _SB_Block _P_(( FILE *,short,short,short,short,colour_t ));
int _SB_Border _P_(( FILE *,short,colour_t ));
int _SB_Cls _P_(( FILE *,short ));
int _SB_Close _P_(( CP_FILE * ));
int _SB_Copy _P_(( char *,char *,short ));
int _SB_Csize _P_(( FILE *,short,short ));
void * _SB_Dateday _P_(( void *,long,int ));
void * _SB_Fills _P_(( void *,char *,int ));
int _SB_Ink _P_(( FILE *,colour_t ));
int _SB_Lbytes _P_(( char *,char * ));
long _SB_Mode _P_(( int ));
int _SB_Open _P_(( CP_FILE *,char *,char * ));
int _SB_Pan _P_(( FILE *,short,short ));
int _SB_Paper _P_(( FILE *,colour_t ));
long _SB_Peek _P_(( void *,int));
void _SB_Poke _P_(( void *,long,int));
void _SB_Randomise _P_(( double ));
char * _SB_Read _P_(( int));
int _SB_Recol _P_(( FILE *,colour_t,colour_t,colour_t,colour_t,\
colour_t,colour_t,colour_t,colour_t ));
char * _SB_Respr _P_(( long,int,int ));
void _SB_Restore _P_(( int,int ));
double _SB_Rnd_f _P_(( void));
int _SB_Rnd_i _P_(( int,int ));
int _SB_Sbytes _P_(( char *,char *,long,int ));
int _SB_Scroll _P_(( FILE *,short,short ));
int _SB_Sexec _P_(( char *,char *,long,int,int ));
int _SB_Strip _P_(( FILE *,colour_t ));
int _SB_Window _P_(( FILE *,short,short,short,short ));
#define SB_Alchp(size) malloc((long)(size))
#define SB_Bin_s(dest,val,len) _SB_Bin_s(dest,(long)val,(int)len)
#define SB_Clchp()
#define SB_Cdec(dest,v,f,n) _SB_Cdec(dest,(long)v,(int)f,(int)n)
#define SB_Data_Use(name) chdir(name)
#define SB_Ddatad() getenv("DATA_USE")
#define SB_Ddown(name) chdir(name)
#define SB_Dest_Use(name) chddir(name)
#define SB_Destd() getenv("DEST_USE")
#define SB_Dnext(target) SB_Dup(),SB_Ddown(target)
#define SB_Dup() chdir(NULL)
#define SB_Fdat(fp) _SB_Fileinfo(fp,6,4)
#define SB_Fdat_s(name) _SB_Fileinfos(name,6,4)
#define SB_Fdec(dest,v,f,n) _SB_Fdec(dest,(double)v,(int)f,(int)n)
#define SB_Fexp(s,v,f,n) _SB_Fexp(s,(double)v,(int)f,(int)n)
#define SB_Flen(fp) _SB_Fileinfo(fp,0,4)
#define SB_Flen_s(name) _SB_Fileinfo_s(name,0,4)
#define SB_Flush(fp) fflush(fp)
#define SB_Fopen(fp,name) _SB_Open((CP_FILE *)&fp,name,"r+")
#define SB_Fop_Dir(fp,name) _SB_Open((CP_FILE *)&fp,name,"d")
#define SB_Fop_In(fp,name) _SB_Open((CP_FILE *)&fp,name,"r")
#define SB_Fop_New(fp,name) _SB_Open((CP_FILE *)&fp,name,"n+")
#define SB_Fop_Over(fp,name) _SB_Open((CP_FILE *)&fp,name,"w+")
#define SB_Fpos(fp) ftell(fp)
#define SB_Free_Mem() mt_free()
#define SB_Ftyp(fp) (char)_SB_Fileinfo(fp,5,1)
#define SB_Ftyp_s(name) (char)_SB_Fileinfo_s(name,5,1)
#define SB_Fupdt(fp) _SB_Fileinfo(fp,52,4)
#define SB_Fupdt_s(name) _SB_Fileinfo_s(name,52,4)
#define SB_Fxtra(fp) _SB_Fileinfo(fp,10,4)
#define SB_Fxtra_s(name) _SB_Fileinfo_s(name,10,4)
#define SB_Hex_s(dest,val,len) _SB_Hex_s(dest,(long)val,(int)len)
#define SB_Idec(dest,v,f,n) _SB_Idec(dest,(long)v,(int)f,(int)n)
#define SB_Open_Dir(fp,name) _SB_Open((CP_FILE *)&fp,name,"d")
#define SB_Progd() getenv("PROG_USE");
#define SB_Prog_Use(name) chpdir(name)
#define SB_Rechp(address) free((char *)address)
#define SB_Rename(old,new) io_rename(old,new)
#define SB_Sbytes_O(nam,ad,len) _SB_Lbytes(nam,(char *)(ad),(long)(len),1)
#define SB_Sexec_O(name,a,l,) _SB_Lbytes(name,(char *)(a),(long)(l),(long)(d),1)
#define SB_Spl_Use(name) chddir(name)
long SB_Bin _P_(( void * ));
int SB_Curdis _P_(( FILE * ));
int SB_Cursen _P_(( FILE * ));
int SB_Dlist _P_(( FILE * ));
char * SB_Fname_s _P_(( FILE * ));
long SB_Hex _P_(( void * ));
int SB_Lrespr _P_(( char * ));
int SB_Stat _P_(( FILE *,char * ));
int SB_Wdel _P_(( FILE *,char * ));
void * _SB_Bin_s _P_(( void *,long,int));
void * _SB_Cdec _P_(( void *,long,int,int));
void * _SB_Fdec _P_(( void *,double,int,int));
void * _SB_Fexp _P_(( void *,double,int,int));
long _SB_Fileinfo _P_(( FILE *,int,int));
long _SB_Fileinfo_s _P_(( char *,int,int));
void * _SB_Hex_s _P_(( void *,long,int));
void * _SB_Idec _P_(( void *,long,int,int));
#define SB_Allocation(size,j1,j2)_SB_Allocation((long)(size),JOB_ID(j1,j2))
#define SB_Basic_B(offset) _SB_Basic_B((int)offset)
#define SB_Basic_F(offset) _SB_Basic_F((int)offset)
#define SB_Basic_L(offset) _SB_Basic_L((int)offset)
#define SB_Basic_W(offset) _SB_Basic_W((int)offset)
#define SB_Basic_Name(dest,ind) _SB_Basic_Name(dest,(int)ind)
#define SB_Basic_Pointer(x) _SB_Basic_Pointer((int)x)
#define SB_Basic_Type(entry) _SB_Basic_Type((int)entry)
#define SB_Channel_Id(fp) fgetchid(fp)
#define SB_Cursor_Off(fp) SB_Curdis(fp)
#define SB_Cursor_On(fp) SB_Cursen(fp)
#define SB_Dataspace(name) _SB_Fileinfo_s(name,6,4)
#define SB_Deallocate(address) mt_rechp((char *)address)
#define SB_Default_Device(name) chpdir(name)
#define SB_Device_Status(mode,name) _SB_Device_Status((int)mode,name)
#define SB_Editf(fp,deflt,num) _SB_Editf (fp,deflt,(short)(num))
#define SB_Edit_i(fp,deflt,num) _SB_Edit_i(fp,deflt,(short)(num))
#define SB_Edit_s(buf,fp,string,num) _SB_Edit_s(buf,fp,string,(short)(num),(short)0)
#define SB_Float(dest,number) (char *)d_to_qlfp((struct QLFLOAT *)dest,(double)number)
#define SB_Free_Memory() mt_free()
#define SB_Integer(dest,value) _SB_Integer(dest,(short)(value))
#define SB_Input_s(dest,fp,len) _SB_Input_s(dest,fp,(short)(len))
#define SB_Move_Memory(src,trg,byts) memmove((void *)trg,(void *)src,(size_t)byts)
#define SB_Peek_s(dest,src,len) _SB_Peeks((void *)dest,(void *)src,(int)(len))
#define SB_Poke_s(target,source) strcpy(target,source)
#define SB_Position(fp) ftell(fp)
#define SB_Release_Task(j1,j2) mt_reljb(JOB_ID(j1,j2))
#define SB_Remove_Task(j1,j2) mt_frjob(JOB_ID(j1,j2))
#define SB_Search_Memory(f,l,s) _SB_Search_Memory((char *)(f),(long)(l),(char *)(s))
#define SB_Set_Channel(fp,chid) ( fp = fusechid((chanid_t)(chid)) )
#define SB_Set_Font(fp,ad1,ad2) sd_fount(fgetchid(fp),NO_TIMEOUT,(char *)(ad1),(char *)(ad2))
#define SB_Set_Position(fp,val) fseek(fp,SEEK_SET)
#define SB_Set_Priority(j1,j2,p) mt_prior(JOB_ID(j1,j2),(int)(p))
#define SB_String(dest,srce) (char *)qlstr_to_c(dest,(struct QLSTR *)src)
#define SB_Stringf(string) qlfp_to_d((struct QLFLOAT *)string)
#define SB_Suspend_Job(t,j1,j2) mt_susjb (JOB_ID(j1,j2),(int)(t),NULL)
#define SB_Sys_Var() _sys_var
#define SB_Truncate(fp) io_trunc(fgetchid(fp),NO_TIMEOUT)
int SB_Basic_Index _P_(( char * ));
int SB_Device_Space _P_(( FILE * ));
short SB_Get_i _P_(( FILE * ));
double SB_Getf _P_(( FILE * ));
char * SB_Get_s _P_(( char *,FILE *));
short SB_String_i _P_(( char * ));
int _SB_Basic_B _P_(( int ));
double _SB_Basic_F _P_(( int ));
long _SB_Basic_L _P_(( int ));
short _SB_Basic_W _P_(( int ));
char * _SB_Basic_Name _P_(( char *,int ));
char * _SB_Basic_Pointer _P_(( int ));
int _SB_Basic_Type _P_(( int ));
int _SB_Device_Status _P_(( int,char * ));
double _SB_Editf _P_(( FILE *,char *,short ));
short _SB_Edit_i _P_(( FILE *,char *,short ));
char * _SB_Edit_s _P_(( char *,FILE *,char *,short,short ));
char * _SB_Integer _P_(( char *,short));
char * _SB_Input_s _P_(( char *,FILE *,short ));
char * _SB_Peeks _P_(( void *,void *,int ));
char * _SB_Search_Memory _P_(( char *,long,char * ));
#define SB_Q_Cursoff(fp) SB_Cursoff(fp)
#define SB_Q_Curson(fp) SB_Cursen(fp)
#define itoa(dest,value) ltoa(dest,(long)value)
#define stoa(dest,value) ltoa(dest,(long)(value))
#define ftoa(dest,value) dtoa(dest,(double)(value))
char * ctoa _P_(( char *,char));
char * dtoa _P_(( char *,double));
char * ltoa _P_(( char *,long));
char * CP_Concat _P_(( char *,char *,char * ));
int CP_Confirm _P_(( FILE *,char *,int * ));
void * CP_Infill _P_(( void *,void *,int ));
void CP_Initialise _P_(( void ));
int CP_MediumData _P_(( chanid_t,char *,long *,long *));
int CP_Mosteqs _P_(( char *,char * ));
int CP_Ok _P_(( CP_FILE *,char * ));
char * CP_Postchar _P_(( char *,char *,char ));
char * CP_Prechar _P_(( char *,char,char * ));
CP_FILE*CP_Qfp _P_(( FILE * ));
char * CP_Slice _P_(( char *,char *,int,int ));
void CP_Sync _P_(( CP_FILE * ));
#undef _P_
#endif _CPORT_H
